! T3X Runtime Class: Character Functions
! Copyright (C) 1999,2000,2002-2004 Nils M Holm. All rights reserved.
! See the file LICENSE for conditions of use.

module char();

var	Cmap;		! pointer to character property map

! Character property flags. These have to be global,
! since they are used in both the CHAR class and the
! initialization code of the module.
const	A = 0x0001,
	U = 0x0002,
	D = 0x0004,
	X = 0x0008,
	S = 0x0010,
	C = 0x0020;

public class char()

 public const	C_ALPHA  = A,
		C_UPPER  = U,
		C_DIGIT  = D,
		C_XDIGIT = X,
		C_SPACE  = S,
		C_CNTRL  = C;

 public map() return Cmap;

 public init() ;

 public ascii(ch) return (ch & ~127) \= 0;

 public alpha(ch) do
	if (ch & ~127) return 0;
	return (Cmap::ch & C_ALPHA) \= 0;
 end

 public upper(ch) do
	if (ch & ~127) return 0;
	return (Cmap::ch & C_UPPER) \= 0;
 end

 public lower(ch) do
	if (ch & ~127) return 0;
	return Cmap::ch & (C_ALPHA|C_UPPER) = C_ALPHA;
 end

 public digit(ch) do
	if (ch & ~127) return 0;
	return (Cmap::ch & C_DIGIT) \= 0;
 end

 public xdigit(ch) do
	if (ch & ~127) return 0;
	return (Cmap::ch & C_XDIGIT) \= 0;
 end

 public space(ch) do
	if (ch & ~127) return 0;
	return (Cmap::ch & C_SPACE) \= 0;
 end

 public cntrl(ch) do
	if (ch & ~127) return 0;
	return (Cmap::ch & C_CNTRL) \= 0;
 end

 public lcase(ch) do
	if (ch & ~127) return ch;
	if (Cmap::ch & C_UPPER) return ch+('a'-'A');
	return ch;
 end

 public ucase(ch) do
	if (ch & ~127) return ch;
	if (Cmap::ch & (C_ALPHA|C_UPPER) = C_ALPHA) return ch+('A'-'a');
	return ch;
 end

 public value(ch) do
	if (ch & ~127) return -1;
	if (Cmap::ch & C_DIGIT) return ch-'0';
	if (\(Cmap::ch & C_XDIGIT)) return -1;
	if (Cmap::ch & C_UPPER) return ch-'A'+10;
	return ch-'a'+10;
 end

end

do
	Cmap := packed [
	C,	C,	C,	C,	C,	C,	C,	C,
	C,	C|S,	C|S,	C|S,	C|S,	C|S,	C,	C,
	C,	C,	C,	C,	C,	C,	C,	C,
	C,	C,	C,	C,	C,	C,	C,	C,
	S,	0,	0,	0,	0,	0,	0,	0,
	0,	0,	0,	0,	0,	0,	0,	0,
	D|X,	D|X,	D|X,	D|X,	D|X,	D|X,	D|X,	D|X,
	D|X,	D,	0,	0,	0,	0,	0,	0,
	0,	A|U|X,	A|U|X,	A|U|X,	A|U|X,	A|U|X,	A|U|X,	A|U,
	A|U,	A|U,	A|U,	A|U,	A|U,	A|U,	A|U,	A|U,
	A|U,	A|U,	A|U,	A|U,	A|U,	A|U,	A|U,	A|U,
	A|U,	A|U,	A|U,	0,	0,	0,	0,	0,
	0,	A|X,	A|X,	A|X,	A|X,	A|X,	A|X,	A,
	A,	A,	A,	A,	A,	A,	A,	A,
	A,	A,	A,	A,	A,	A,	A,	A,
	A,	A,	A,	0,	0,	0,	0,	C
 	];
end
