! GENCLDIRS -- Generate initial class directories
! Copyright (C) 1999,2000,2002 Nils M Holm. All rights reserved.
! See the file LICENSE for conditions of use.
!
! USAGE: GENCLDIRS <CLASSDIR

#classpath "../compiler";

module gencldirs(t3x);

object	t[t3x];

const	MAXNAMES = 512;

!--- From TXTRN ---!
struct	SYMREC =
	SNAME,
	SVAL,
	SSIZE,
	SFLAGS;
! byte-order-independent SYMREC
struct XSYMREC =
		XHHVAL,	XHLVAL, XLHVAL, XLLVAL,
		XHHSIZE, XHLSIZE, XLHSIZE, XLLSIZE,
		XHFLGS,	XLFLGS;
const	CNST=	1,	! Symbol Flags
	GLOBL=	2,
	PROC=	4,
	PROTO=	8,
	IPROC=	32,
	PUBLC=	64,
	EXTRN=	128,
	CLSS=	256,
	OBJCT=	512,
	IVAR=	1024,
	REDIR=	2048,
	LINKD=	4096;
const	CACHESPACE =	4096,
	NAMESPACE =	8192;
!------------------!

var	Symbols[CACHESPACE];
var	Names::NAMESPACE+1;
var	Nameptrs[MAXNAMES];
var	Xbpw;

length(s) do var k;
	k := 0;
	while (s::k) k := k+1;
	return k;
end

writep(f, s) t.write(T3X.SYSOUT, s, length(s));

wrout(s) writep(T3X.SYSOUT, s);

nl(f) do var b::3;
	writep(f, t.newline(b));
end

error(m) do
	writep(T3X.SYSERR, "GENCLDIR: ");
	writep(T3X.SYSERR, m);
	nl(T3X.SYSERR);
	halt 1;
end

writedir(nlist, tbl, n) do
	var	k, i, dir, dirname::256, name, s, sfx;
	var	fwerr, hd;
	var	nb::2;

	fwerr := "file write error";
	s := nlist[0];
	t.memcopy(dirname, s, length(s)+1);
	k := 0;
	while (dirname::k) k := k+1;
	sfx := ".dir";
	for (i=0, 5) dirname::(k+i) := sfx::i;
	name := dirname;
	wrout(name);
	nl(T3X.SYSOUT);
	dir := t.open(name, T3X.OWRITE);
	if (dir < 0) error("file creation failed");
	hd := "CDR#";
	hd::3 := Xbpw;
	if (t.write(dir, hd, 4) \= 4) error(fwerr);
	nb::0 := n >> 8;
	nb::1 := n;
	if (t.write(dir, nb, 2) \= 2) error(fwerr);
	if (t.write(dir, tbl, n*XSYMREC) \= n*XSYMREC) error(fwerr);
	for (i=0, n) do
		s := nlist[i];
		k := 0;
		while (s::k) k := k+1;
		k := k+1;
		if (t.write(dir, s, k) \= k) error(fwerr);
	end
	t.close(dir);
end

gencldirs(n) do var i, j, f, x;
	for (x=0, n) do
		i := x*XSYMREC;
		f := Symbols::(i+XHFLGS) << 8 | Symbols::(i+XLFLGS);
		if (f & CLSS) do
			j := i;
			while (1) do
				if (	\(Symbols::(j+XHFLGS) << 8 |
					  Symbols::(j+XLFLGS))
				)
					leave;
				if (j >= n*XSYMREC)
					error("missing end of class");
				j := j+XSYMREC;
			end
			writedir(@Nameptrs[x], @Symbols::i,
				(j+XSYMREC-i)/XSYMREC);
		end
	end
end

do var hd::4, i, n, p, nb::2;
	if (t.read(0, hd, 4) \= 4 \/ t.memcomp(hd, "CDR", 3))
		error("magic match failed");
	Xbpw := hd::3;
	if (t.read(0, nb, 2) \= 2) error("short file");
	n := nb::0 << 8 | nb::1;
	if (t.read(0, Symbols, n*XSYMREC) \= n*XSYMREC)
 		error("short file");
	if (t.read(0, Names, NAMESPACE+1) = NAMESPACE+1)
		error("file too long");
	p := 0;
	for (i=0, n) do
		Nameptrs[i] := @Names::p;
		p := p+length(@Names::p)+1;
	end
	gencldirs(n);
end
