! T3X Runtime Extension: System Interface
! Copyright (C) 1999,2000,2002 Nils M Holm. All rights reserved.
! See the file LICENSE for conditions of use.

module system(t3x);

public iclass system("system")

 object	t[t3x];

 public const	SPAWN_WAIT = 1,		! spawn: wait for process termination
		SPAWN_NOWAIT = 0;	! spawn: do not wait

 public const	SIGTEST = 0,	! kill: test PID
		SIGTERM = 15,	! kill: terminate process
		SIGKILL = 9;	! kill: force termination

 public struct STATBUF =	! file status buffer
		ST_DEV,		! device (or 0)
		ST_INO,		! inode ID (or 0)
		ST_MODE,	! access bits, see below
		ST_NLINK,	! number of links (names)
		ST_UID,		! user ID (or 0)
		ST_GID,		! group ID (or 0)
		ST_RDEV,	! device type (or 0)
		ST_SIZE,	! size mod 65536
		ST_EXT64,	! size / 65536 mod 65536
		ST_MTIME,	! modification time, century, year (0-99)
		ST_MT_2,	! + month (1-12), day (1-31)
		ST_MT_3,	! + hours (0-23), minutes (0-59)
		ST_MT_4;	! + seconds (0-59), seconds/100 (0-99)

 ! file access/type bits
 public const	FM_RDOK = 0x01,	! file: read ok, dir: read ok
		FM_WROK = 0x02,	! file: write ok, dir: create/delete ok
		FM_EXOK = 0x04,	! file: execute ok, dir: search ok
		FM_ISDIR= 0x08;	! file is a directory

 idecl init(0,0);
 idecl pipe(1,1);
 idecl dup(1,0);
 idecl dup2(2,0);
 idecl rdchk(1,0);
 idecl chdir(1,1);
 idecl mkdir(1,1);
 idecl rmdir(1,1);
 idecl getdir(2,1);
 idecl opendir(1,1);
 idecl readdir(3,2);
 idecl closedir(1,0);
 idecl fork(0,0);
 idecl wait(1,0);
 idecl kill(2,0);
 idecl time(1,1);
 idecl fini(0,0);

 idecl _spawn(3,3);

 public spawn(prog, args, mode) do
	var	abuf::144, n, m, adj;

	n := 0;
	m := 0;
	while (args[n]) do
		ie (m)
			m := m<<1 | 1;
		else
			m := 1;
		n := n+1;
	end
	adj := t.cvalist(n+1, m, args, abuf);
	return self._spawn(prog, @abuf::adj, mode);
 end

 idecl _stat(2,3);

 public stat(path, sb) do var a[STATBUF], x, r;
	r := self._stat(path, a);
	x := a::0 << 8 | a::1;   sb[ST_DEV] := x;
	x := a::2 << 8 | a::3;   sb[ST_INO] := x;
	x := a::4 << 8 | a::5;   sb[ST_MODE] := x;
	x := a::6 << 8 | a::7;   sb[ST_NLINK] := x;
	x := a::8 << 8 | a::9;   sb[ST_UID] := x;
	x := a::10 << 8 | a::11; sb[ST_GID] := x;
	x := a::12 << 8 | a::13; sb[ST_RDEV] := x;
	x := a::14 << 8 | a::15; sb[ST_SIZE] := x;
	x := a::16 << 8 | a::17; sb[ST_EXT64] := x;
	t.memcopy(@sb[ST_MTIME], @a::18, 8);
	return r;
 end

end

do end
