#!/bin/sh

# T3X Compiler Boostrap Driver
# Copyright (C) 2003 Nils M Holm. All rights reserved.
# See the file LICENSE for conditions of use.

case x$1 in
	x-1)	stage=1
		shift
		;;
	x-2)	stage=2
		shift
		;;
	x-3)	stage=3
		shift
		;;
	x)	echo "Usage: txboot [-123] program.t [libraries]"
		exit 1
		;;
	x*)	stage=4
		;;
esac

case $stage in
	1)	N=`basename $1 .t`
		T=${N}_1
		O=$T
		TXTRN="../compiler/txx ../Boot/txtrn.tcode"
		TXLD="../compiler/txx ../Boot/txld.tcode"
		TXOPT="n/a"
		TXDPF="n/a"
		TXCG="../compiler/txx ../compiler/txcguc.tcode"
		TXLIB="../compiler/t3x.o"
		;;
	2)	N=`basename $1 .t`
		T=${N}_2
		O=$T
		TXTRN="../compiler/txtrn_1"
		TXLD="../compiler/txld_1"
		TXOPT="n/a"
		TXDPF="n/a"
		TXCG="../compiler/txcguc_1"
		TXLIB="../compiler/t3x.o"
		;;
	3)	N=`basename $1 .t`
		T=${N}_3
		O=$N
		TXTRN="../compiler/txtrn_2"
		TXLD="../compiler/txld_2"
		TXOPT="../compiler/txopt_2"
		TXDPF="../compiler/txdpf_2"
		TXCG="../compiler/txcguc_2"
		TXLIB="../compiler/t3x.o"
		;;
	4)	N=`basename $1 .t`
		T=${N}_4
		O=$N
		TXTRN="../compiler/txtrn"
		TXLD="../compiler/txld"
		TXOPT="../compiler/txopt"
		TXDPF="../compiler/txdpf"
		TXCG="../compiler/txcguc"
		TXLIB="../compiler/t3x.o"
		;;
esac

shift

rm -f CLASSDIR LIBDIR

echo -n "$N: T"
$TXTRN <$N.t >$T.tcode

if [ "$TXLD" != "n/a" ]; then
	echo -n "L"
	cat ../compiler/t3x.cls >$T.tmp
	if [ "$*" != "" ]; then
		echo -n "(t3x"
		for lib in $*; do
			echo -n ",$lib"
			if [ -f $lib.cls ]; then
				cat $lib.cls >>$T.tmp
			else
				cat ../classes/$lib.cls >>$T.tmp
			fi
		done
		echo -n ")"
	fi
	cat $T.tcode >>$T.tmp
	$TXLD <$T.tmp >$T.tcode
	rm -f $T.tmp
fi

if [ "$TXOPT" != "n/a" -a "$TXDPF" != "n/a" ]; then
	echo -n "O"
	$TXOPT <$T.tcode >$T.tmp
	echo -n "D"
	$TXDPF <$T.tmp >$T.tcode
	rm -f $T.tmp
fi

echo -n "G"
$TXCG <$T.tcode >$T.c
rm -f $T.tcode

echo -n "N"
cc -c -w -o $T.o $T.c
rm -f $T.c
cc -o $O $T.o $TXLIB
rm -f $T.o
echo ""
