! Dumb file compare utility for DOS.
! Copyright (C) 2003 Nils M Holm.
! See the file LICENSE for conditions of use.
!
! This program is used to compare the stages
! during the triple test. It was added because
! some DOS versions do not have a file compare
! utility that returns a meaningful exit status.
!
! Usage: CMP file1 file2
!
! Exit code: 0 = files are equal
!            1 = files differ
!            2 = bad usage

module cmp(t3x, string);

object	t[t3x], str[string];

ws(s) t.write(T3X.SYSERR, s, str.length(s));

wl(s) do var b::4;
	ws(s);
	ws(t.newline(b));
end

msg(s, s2) do
	ws("cmp: ");
	ws(s2);
	ws(": ");
	wl(s);
	halt 1;
end

usage() do
	wl("Usage: cmp file1 file2");
	halt 2;
end

do var fn1::128, fn2::128, b1::1024, b2::1024, k1, k2 , fd1, fd2;
	if (t.getarg(1, fn1, 128) < 1) usage();
	if (t.getarg(2, fn2, 128) < 1) usage();
	fd1 := t.open(fn1, T3X.OREAD);
	if (fd1 < 0) msg("cannot open", fn1);
	fd2 := t.open(fn2, T3X.OREAD);
	if (fd2 < 0) msg("cannot open", fn2);
	while (1) do
		k1 := t.read(fd1, b1, 1024);
		k2 := t.read(fd2, b2, 1024);
		if (k1 < 1 /\ k2 < 1) leave;
		if (k1 < k2) msg("EOF encountered", fn1);
		if (k2 < k1) msg("EOF encountered", fn2);
		if (t.memcomp(b1, b2, k1)) do
			ws("cmp: ");
			ws(fn1);
			ws(", ");
			ws(fn2);
			wl(": files differ");
			halt 1;
		end
	end
	t.close(fd1);
	t.close(fd2);
end
