! T3X compiler test suite, part #1
! Copyright (C) 2004 Nils M Holm

#!
	You need T3X 8.1.4 or a later version to complete this
	test sucessfully.

	This text is contained in a so-called meta comment. Meta
	comments have been added in version 8.1.4 and look like
	this:

	#! this is a meta comment !#

	Since they can be nested, above comment-in-a-comment will
	not cause any trouble.
!#

#!!#
#!#!!#!#
#!#!#!!#!#!#
#!#!!##!#!!#!#!#

module test(t3x, string, util);

object	t[t3x], str[string], u[util];

var very_long_symbol_789012345678901234567890123456789012345678901234567890123456789012345678901234567890123456789012345678901234567;

printf() do
	u.printf("PF01: Here the fun begins = Here the fun begins\n", 0);
	u.printf("PF02: '%c', %d, 0b%b, 0x%x = '%c', %d, 0b%b, 0x%x\n",
		[('a', 'a', 'a', 'a', 'a', 'a', 'a', 'a')]);
	u.printf("PF03: 0b%16:0b, 0x%4:0x = 0b%16:0b, 0x%4:0x\n",
		[(12345,12345,12345,12345)]);
	u.printf("PF04: \"%7:\ss%s\" = \"%7:\ss%s\"\n",
		["Hello,", "World!", "Hello,", "World!"]);
end

const	GC_a = 1;
const	GC_b = 123, GC_c = %3;
const	GC_d = GC_c;

const	GC_x0 = -1,
	GC_x1 = 1+2,
	GC_x2 = 1-2,
	GC_x3 = 3*4,
	GC_x4 = 12 | 34,
	GC_x5 = ~0;

const	GC_z1 = 1 | 2 + 3 * 4;
const	GC_z2 = 1 + 2 | 3 * 4;
const	GC_z3 = 1 * 2 + 3 | 4;
const	GC_z4 = 1 | 2 * 3 + 4;
const	GC_z5 = 1 + 2 * 3 | 4;
const	GC_z6 = 1 * 2 | 3 + 4;
const	GC_z7 = -5 * -7;
const	GC_z8 = ~127 | ~15;

global_const() do
	u.printf("GC01: 1 = %d\n", [(GC_a)]);
	u.printf("GC02: 123 = %d\n", [(GC_b)]);
	u.printf("GC03: -3 = %d\n", [(GC_c)]);
	u.printf("GC04: %d = %d\n", [(GC_c, GC_d)]);
	u.printf("GC05: -1 = %d\n", [(GC_x0)]);
	u.printf("GC06: 3 = %d\n", [(GC_x1)]);
	u.printf("GC07: -1 = %d\n", [(GC_x2)]);
	u.printf("GC08: 12 = %d\n", [(GC_x3)]);
	u.printf("GC09: 46 = %d\n", [(GC_x4)]);
	u.printf("GC10: 32767 = %d\n", [(GC_x5 & 0x7fff)]);
	u.printf("GC11: 24 = %d\n", [(GC_z1)]);
	u.printf("GC12: 12 = %d\n", [(GC_z2)]);
	u.printf("GC13: 5 = %d\n", [(GC_z3)]);
	u.printf("GC14: 13 = %d\n", [(GC_z4)]);
	u.printf("GC15: 13 = %d\n", [(GC_z5)]);
	u.printf("GC16: 7 = %d\n", [(GC_z6)]);
	u.printf("GC17: 35 = %d\n", [(GC_z7)]);
	u.printf("GC18: 32752 = %d\n", [(GC_z8 & 0x7fff)]);
end

local_const() do
	const	a = 1;
	const	b = 123, c = %3;
	const	d = c;
	
	const	x0 = -1,
		x1 = 1+2,
		x2 = 1-2,
		x3 = 3*4,
		x4 = 12 | 34,
		x5 = ~0;
	
	const	z1 = 1 | 2 + 3 * 4;
	const	z2 = 1 + 2 | 3 * 4;
	const	z3 = 1 * 2 + 3 | 4;
	const	z4 = 1 | 2 * 3 + 4;
	const	z5 = 1 + 2 * 3 | 4;
	const	z6 = 1 * 2 | 3 + 4;
	const	z7 = -5 * -7;
	const	z8 = ~127 | ~15;

	u.printf("LC01: 1 = %d\n", [(a)]);
	u.printf("LC02: 123 = %d\n", [(b)]);
	u.printf("LC03: -3 = %d\n", [(c)]);
	u.printf("LC04: %d = %d\n", [(c, d)]);
	u.printf("LC05: -1 = %d\n", [(x0)]);
	u.printf("LC06: 3 = %d\n", [(x1)]);
	u.printf("LC07: -1 = %d\n", [(x2)]);
	u.printf("LC08: 12 = %d\n", [(x3)]);
	u.printf("LC09: 46 = %d\n", [(x4)]);
	u.printf("LC10: 32767 = %d\n", [(x5 & 0x7fff)]);
	u.printf("LC11: 24 = %d\n", [(z1)]);
	u.printf("LC12: 12 = %d\n", [(z2)]);
	u.printf("LC13: 5 = %d\n", [(z3)]);
	u.printf("LC14: 13 = %d\n", [(z4)]);
	u.printf("LC15: 13 = %d\n", [(z5)]);
	u.printf("LC16: 7 = %d\n", [(z6)]);
	u.printf("LC17: 35 = %d\n", [(z7)]);
	u.printf("LC18: 32752 = %d\n", [(z8 & 0x7fff)]);
end

const	VECSIZE = 1000,
	BVECSIZE = 1000;

var	GV_a;
var	GV_b, GV_c;
var	GV_v1[VECSIZE], GV_b1::VECSIZE;
var	GV_v2[VECSIZE * 2 + VECSIZE];
var	GV_b2 :: VECSIZE * 2 + VECSIZE;

global_var() do var i;
	GV_a := 12345;
	GV_b := GV_a;
	GV_c := GV_b;
	u.printf("GV01: 12345 = %d\n", [(GV_a)]);
	u.printf("GV02: 12345 = %d\n", [(GV_b)]);
	u.printf("GV03: 12345 = %d\n", [(GV_c)]);
	for (i=0, VECSIZE)
		GV_v1[i] := i;
	for (i=0, VECSIZE)
		if (GV_v1[i] \= i) leave;
	u.printf("GV04: %d = %d\n", [VECSIZE, (i)]);
	for (i=0, BVECSIZE)
		GV_b1::i := i mod 255;
	for (i=0, BVECSIZE)
		if (GV_B1::i \= i mod 255) leave;
	u.printf("GV05: %d = %d\n", [BVECSIZE, (i)]);
	u.printf("GV06: %d = %d\n", [(GV_v1, @GV_v1[0])]);
	u.printf("GV07: %d = %d\n", [(GV_b1, @GV_b1::0)]);
end

local_var() do
	var	i;
	var	a;
	var	b, c;
	var	v1[VECSIZE], b1::VECSIZE;
	var	v2[VECSIZE * 2 + VECSIZE];
	var	b2 :: VECSIZE * 2 + VECSIZE;

	a := 12345;
	b := a;
	c := b;
	u.printf("LV01: 12345 = %d\n", [(a)]);
	u.printf("LV02: 12345 = %d\n", [(b)]);
	u.printf("LV03: 12345 = %d\n", [(c)]);
	for (i=0, VECSIZE)
		v1[i] := i;
	for (i=0, VECSIZE)
		if (v1[i] \= i) leave;
	u.printf("LV04: %d = %d\n", [VECSIZE, (i)]);
	for (i=0, BVECSIZE)
		b1::i := i mod 255;
	for (i=0, BVECSIZE)
		if (B1::i \= i mod 255) leave;
	u.printf("LV05: %d = %d\n", [BVECSIZE, (i)]);
	u.printf("LV06: %d = %d\n", [(v1, @v1[0])]);
	u.printf("LV07: %d = %d\n", [(b1, @b1::0)]);
end

literals() do var s, buf::300;
	u.printf("LT01: 12345 = %d\n", [12345]);
	u.printf("LT02: 0x4321 = 0x%x\n", [0x4321]);
	u.printf("LT03: 0b10100101 = 0b%b\n", [0b10100101]);
	u.printf("LT04: -12345 = %d\n", [%12345]);
	u.printf("LT05: -4321 = %x\n", [%0x4321]);
	u.printf("LT06: -10100101 = %b\n", [%0b10100101]);
	u.printf("LT07: a = %c\n", ['a']);
	u.printf("LT08: Z = %c\n", ['Z']);
	u.printf("LT09: \qSome text\q = %s\n", ["\qSome text\q"]);
	u.printf("LT10: \qpacked vector\q = %s\n",
		[packed['"','p','a','c','k','e','d',
		' ','v','e','c','t','o','r','"',0]]);
	s := "very_long_string_789012345678901234567890123456789012345678901234567890123456789012345678901234567890123456789012345678901234567";
	str.format(buf, "LT11: \q%s\q = \q%s\q\n", [(s, s)]);
	t.write(T3X.SYSOUT, buf, str.length(buf));
	u.printf("LT12: 32767 = %d\n", [ 32767 ]);
	u.printf("LT13: -32767 = %d\n", [ %32767 ]);
end

static_tables() do
	var	t1, t2, t3, i;

	t1 := [
		[ [1,2,3], [4,5,6], [7,8,9] ],
		[ [2,4,6], [8,10,12], [14,16,18] ],
		[ [3,6,9], [12,15,18], [21,24,27] ]
	];
	u.printf("TA01: [1,2,3] = [%d,%d,%d]\n",
		[(t1[0][0][0], t1[0][0][1], t1[0][0][2])]);
	u.printf("TA02: [4,5,6] = [%d,%d,%d]\n",
		[(t1[0][1][0], t1[0][1][1], t1[0][1][2])]);
	u.printf("TA03: [7,8,9] = [%d,%d,%d]\n",
		[(t1[0][2][0], t1[0][2][1], t1[0][2][2])]);
	u.printf("TA04: [2,4,6] = [%d,%d,%d]\n",
		[(t1[1][0][0], t1[1][0][1], t1[1][0][2])]);
	u.printf("TA05: [8,10,12] = [%d,%d,%d]\n",
		[(t1[1][1][0], t1[1][1][1], t1[1][1][2])]);
	u.printf("TA06: [14,16,18] = [%d,%d,%d]\n",
		[(t1[1][2][0], t1[1][2][1], t1[1][2][2])]);
	u.printf("TA07: [3,6,9] = [%d,%d,%d]\n",
		[(t1[2][0][0], t1[2][0][1], t1[2][0][2])]);
	u.printf("TA08: [12,15,18] = [%d,%d,%d]\n",
		[(t1[2][1][0], t1[2][1][1], t1[2][1][2])]);
	u.printf("TA09: [21,24,27] = [%d,%d,%d]\n",
		[(t1[2][2][0], t1[2][2][1], t1[2][2][2])]);
	t2 := [
		  0,   1,   2,   3,   4,   5,   6,   7,
		  8,   9,  10,  11,  12,  13,  14,  15,
		 16,  17,  18,  19,  20,  21,  22,  23,
		 24,  25,  26,  27,  28,  29,  30,  31,
		 32,  33,  34,  35,  36,  37,  38,  39,
		 40,  41,  42,  43,  44,  45,  46,  47,
		 48,  49,  50,  51,  52,  53,  54,  55,
		 56,  57,  58,  59,  60,  61,  62,  63,
		 64,  65,  66,  67,  68,  69,  70,  71,
		 72,  73,  74,  75,  76,  77,  78,  79,
		 80,  81,  82,  83,  84,  85,  86,  87,
		 88,  89,  90,  91,  92,  93,  94,  95,
		 96,  97,  98,  99, 100, 101, 102, 103,
		104, 105, 106, 107, 108, 109, 110, 111,
		112, 113, 114, 115, 116, 117, 118, 119,
		120, 121, 122, 123, 124, 125, 126, 127,
	];
	for (i=0, 128)
		if (t2[i] \= i) leave;
	u.printf("TA10: 128 = %d\n", [(i)]);
	t3 := packed[
		  0,   1,   2,   3,   4,   5,   6,   7,
		  8,   9,  10,  11,  12,  13,  14,  15,
		 16,  17,  18,  19,  20,  21,  22,  23,
		 24,  25,  26,  27,  28,  29,  30,  31,
		 32,  33,  34,  35,  36,  37,  38,  39,
		 40,  41,  42,  43,  44,  45,  46,  47,
		 48,  49,  50,  51,  52,  53,  54,  55,
		 56,  57,  58,  59,  60,  61,  62,  63,
		 64,  65,  66,  67,  68,  69,  70,  71,
		 72,  73,  74,  75,  76,  77,  78,  79,
		 80,  81,  82,  83,  84,  85,  86,  87,
		 88,  89,  90,  91,  92,  93,  94,  95,
		 96,  97,  98,  99, 100, 101, 102, 103,
		104, 105, 106, 107, 108, 109, 110, 111,
		112, 113, 114, 115, 116, 117, 118, 119,
		120, 121, 122, 123, 124, 125, 126, 127,
	];
	for (i=0, 128)
		if (t3::i \= i) leave;
	u.printf("TA11: 128 = %d\n", [(i)]);
end

address_op() do var v, b, p, i, a, c::1, nv, nb;
	a := -999;
	p := @a;
	u.printf("AD01: %d = %d\n", [(a, p[0])]);
	p[0] := 2323;
	u.printf("AD02: %d = %d\n", [(a, p[0])]);
	c::0 := 'm';
	p := @c::0;
	u.printf("AD03: %d = %d\n", [(c::0, p::0)]);
	p::0 := '!';
	u.printf("AD04: %d = %d\n", [(c::0, p::0)]);
	v := [ 1234, 5678, 9012, 3456, 7890 ];
	b := packed [ 12, 34, 56, 78, 90 ];
	p := @v[0]; u.printf("AD05: 1234 = %d\n", [(p[0])]);
	p := @v[1]; u.printf("AD06: 5678 = %d\n", [(p[0])]);
	p := @v[2]; u.printf("AD07: 9012 = %d\n", [(p[0])]);
	p := @v[3]; u.printf("AD08: 3456 = %d\n", [(p[0])]);
	p := @v[4]; u.printf("AD09: 7890 = %d\n", [(p[0])]);
	p := @b::0; u.printf("AD10: 12 = %d\n", [(p::0)]);
	p := @b::1; u.printf("AD11: 34 = %d\n", [(p::0)]);
	p := @b::2; u.printf("AD12: 56 = %d\n", [(p::0)]);
	p := @b::3; u.printf("AD13: 78 = %d\n", [(p::0)]);
	p := @b::4; u.printf("AD14: 90 = %d\n", [(p::0)]);
	nv := [ 2, [ 3, [ 5 ], 11 ], 13 ];
	p := @nv[0]; u.printf("AD15: %d = %d\n", [(nv[0], p[0])]);
	p := @nv[1][0]; u.printf("AD16: %d = %d\n", [(nv[1][0], p[0])]);
	p := @nv[1][1][0]; u.printf("AD17: %d = %d\n", [(nv[1][1][0], p[0])]);
	p := @nv[1][2]; u.printf("AD18: %d = %d\n", [(nv[1][2], p[0])]);
	p := @nv[2]; u.printf("AD19: %d = %d\n", [(nv[2], p[0])]);
	nb := packed [ 2, 3, 5, 11, 13 ];
	p := @nb::0; u.printf("AD20: %d = %d\n", [(nb::0, p::0)]);
	p := @nb::1; u.printf("AD21: %d = %d\n", [(nb::1, p::0)]);
	p := @nb::2; u.printf("AD22: %d = %d\n", [(nb::2, p::0)]);
	p := @nb::3; u.printf("AD23: %d = %d\n", [(nb::3, p::0)]);
	p := @nb::4; u.printf("AD24: %d = %d\n", [(nb::4, p::0)]);
end

P0() return 7;

P1(x) return x*x;

P2(x,y) return x+y;

P3(x,y,z) return x-y^z;

P4(x,y,z,a) return x-y * z-a;

P5(x,y,z,a,b) return x+y+z^a+b;

procedures() do
	u.printf("PR01: 7 = %d\n", [(P0())]);
	u.printf("PR02: 25 = %d\n", [(P1(5))]);
	u.printf("PR03: 12 = %d\n", [(P2(5,7))]);
	u.printf("PR04: -17 = %d\n", [(P3(11,13,17))]);
	u.printf("PR05: -10907 = %d\n", [(P4(101, 123, 89, 61))]);
	u.printf("PR06: 4710 = %d\n", [(P5(1234, 5678, 9012, 3456, 7890))]);
	u.printf("PR07: 49 = %d\n", [(P1(P0()))]);
	u.printf("PR08: 2401 = %d\n", [(P1(P1(P0())))]);
	u.printf("PR09: 128 = %d\n", [(P2(P0(), P1(11))]);
	u.printf("PR10: 74 = %d\n", [(P2(P1(5), P1(7))]);
	u.printf("PR11: 22 = %d\n", [(P3(P1(5), P2(P0(), P0()), 29)]);
	u.printf("PR12: -297 = %d\n", [(P4(P1(7), P1(5), P1(3), P1(11))]);
	u.printf("PR13: -477 = %d\n", [(P5(P0(), P1(2), P2(3,5), P3(7,11,13),
		P4(17,19,23,29))]);
end

conditions() do
	if (0) u.printf("CO01: if(0) = failed\n", 0);
	if (1) u.printf("CO02: if(1) = if(1)\n", 0);
	ie (0)
		u.printf("CO03: ie(0) = failed\n", 0);
	else
		u.printf("CO03: ie(0) = ie(0)\n", 0);
	ie (1)
		u.printf("CO04: ie(1) = ie(1)\n", 0);
	else
		u.printf("CO04: ie(1) = failed\n", 0);
	if (\0) u.printf("CO05: if(\\0) = if(\\0)\n", 0);
	if (\1) u.printf("CO06: if(\\1) = failed\n", 0);
	ie (\0)
		u.printf("CO07: ie(\\0) = ie(\\0)\n", 0);
	else
		u.printf("CO07: ie(0) = failed\n", 0);
	ie (\1)
		u.printf("CO08: ie(\\1) = failed\n", 0);
	else
		u.printf("CO08: ie(\\1) = ie(\\1)\n", 0);
	if (%1) u.printf("CO09: if(%1) = if(%1)\n", 0);
	if (5+7) u.printf("CO10: if(5+7) = if(5+7)\n", 0);
	if (P0()) u.printf("CO11: if(P0()) = if(P0())\n", 0);
	if ("text") u.printf("CO12: if(\"text\") = if(\"text\")\n", 0);
	if (\(2*3-6)) u.printf("CO13: if(\\(2*3-6)) = if(\\(2*3-6))\n", 0);
	if (\(P0()-P0()))
		u.printf("CO14: if(\\(P0()-P0())) = if(\\(P0()-P0()))\n", 0);
	if (P3(5,7,11))
		u.printf("CO15: if(P3(5,7,11)) = if(P3(5,7,11))\n", 0);
	if (\(P3(5,7,11)-P3(5,7,11)))
		u.printf("CO16: if(\(P3(5,7,11)-P3(5,7,11))) = if(\(P3(5,7,11)-P3(5,7,11)))\n", 0);
	if (1|5+7*P0()) u.printf("CO17: if(1|5+7*P0()) = if(1|5+7*P0())\n", 0);
end

wloops() do var i;
	while (0) u.printf("WL01: while(0) = failed\n", 0);
	i := 1;
	while (i) do
		u.printf("WL02: while(i) = while(i)\n", 0);
		i := 0;
	end
	i := 0;
	while (i < 10) do
		u.printf("WL%2:0d: while(%d < %d) = while(%d < %d)\n", 
			[(i,i,i,i,i)]);
		i := i+1;	
	end
	u.printf("WL%2:0d: while(%d < %d) = while(%d < %d)\n", 
		[(i,i,i,i,i)]);
	i := 2;
	while (i+10 <= 10+P2(5,7)) do
		u.printf("WL%2:0d: while(%d < %d) = while(%d < %d)\n", 
			[(i+9,i,i,i,i)]);
		i := i+1;	
	end
	i := 1;
	while (1) do
		if (i) do
			i := 0;
			loop;
			u.printf("WL21: loop = failed\n", 0);
		end
		u.printf("WL21: loop = loop\n", 0);
		leave;
		u.printf("WL22: leave = failed\n", 0);
	end
	u.printf("WL22: leave = leave\n", 0);
end

floops() do var i;
	for (i=0,0) u.printf("FL01: for(i=0,0) = failed\n", 0);
	! FL02
	for (i=0,1) do
		u.printf("FL02: for(%d,1) = for(0,1)\n", [(i)]);
		i := 0;
	end
	! FL03 - FL12
	for (i=0,10) do
		u.printf("FL%2:0d: for(%d,10) = for(%d,10)\n", 
			[(i+3,i,i)]);
	end
	! FL13
	u.printf("FL%2:0d: for(%d,10) = for(%d,10)\n", 
		[(i+3,i,i)]);
	! FL14 - FL23
	for (i=12,10+P2(5,7)) do
		u.printf("FL%2:0d: for(%d,22) = for(%d,22)\n", 
			[(i+2,i,i)]);
	end
	! FL24- FL33
	for (i=9,-1,-1) do
		u.printf("FL%2:0d: for(%d,-1) = for(%d,-1)\n", 
			[(33-i,i,i)]);
	end
	! FL34 - FL40
	for (i=0,50,7) do
		u.printf("FL%2:0d: for(%d,10) = for(%d,10)\n", 
			[(i/7+34,i,i)]);
	end
	! FL41 - FL48
	for (i=0,50,1) do
		u.printf("FL%2:0d: for(%d,10) = for(%d,10)\n", 
			[(i/7+41,i,i)]);
		i := i+6;
	end
	for (i=0,-1,0) do
		if (i) do
			i := 0;
			loop;
			u.printf("LO49: loop = failed\n", 0);
		end
		u.printf("LO49: loop = loop\n", 0);
		leave;
		u.printf("LO50: leave = failed\n", 0);
	end
	u.printf("LO50: leave = leave\n", 0);
end

condexpr() do var TRUE,FALSE;
	FALSE := 0;
	TRUE := \FALSE;
	u.printf("CE01: 1234 = %d\n", [(TRUE /\ 1234)]);
	u.printf("CE02: 2345 = %d\n", [(TRUE /\ TRUE /\ TRUE /\ TRUE /\ 2345)]);
	u.printf("CE03: 543 = %d\n", [(FALSE \/ 543)]);
	u.printf("CE04: 432 = %d\n",
		[(FALSE \/ FALSE \/ FALSE \/ FALSE \/ 432)]);
	u.printf("CE05: yes = %s\n", [(TRUE-> "yes": "no")]);
	u.printf("CE06: no = %s\n", [(FALSE-> "yes": "no")]);
	u.printf("CE07: default = %s\n", [(FALSE-> "case1":
					FALSE-> "case2":
					"default")]);
	u.printf("CE08: case2 = %s\n", [(FALSE-> "case1":
					TRUE-> "case2":
					"default")]);
	u.printf("CE09: case1 = %s\n", [(TRUE-> "case1":
					FALSE-> "case2":
					"default")]);
	u.printf("CE10: case1 = %s\n", [(TRUE-> "case1":
					TRUE-> "case2":
					"default")]);
	u.printf("CE11: FF = %s\n", [(FALSE->
					FALSE-> "TT": "TF":
					FALSE->"FT": "FF")]);
	u.printf("CE12: FT = %s\n", [(FALSE->
					FALSE-> "TT": "TF":
					TRUE->"FT": "FF")]);
	u.printf("CE13: FF = %s\n", [(FALSE->
					TRUE-> "TT": "TF":
					FALSE->"FT": "FF")]);
	u.printf("CE14: TF = %s\n", [(TRUE->
					FALSE-> "TT": "TF":
					FALSE->"FT": "FF")]);
	u.printf("CE15: TT = %s\n", [(TRUE->
					TRUE-> "TT": "TF":
					FALSE->"FT": "FF")]);
	u.printf("CE16: TF = %s\n", [(TRUE->
					FALSE-> "TT": "TF":
					TRUE->"FT": "FF")]);
	u.printf("CE17: TT = %s\n", [(TRUE->
					TRUE-> "TT": "TF":
					TRUE->"FT": "FF")]);
	u.printf("CE18: TRUE = %s\n", [(TRUE /\ TRUE -> "TRUE" : "FALSE")]);
	u.printf("CE19: FALSE = %s\n", [(TRUE /\ FALSE -> "TRUE" : "FALSE")]);
	u.printf("CE20: FALSE = %s\n", [(FALSE /\ TRUE -> "TRUE" : "FALSE")]);
	u.printf("CE21: FALSE = %s\n", [(FALSE /\ FALSE -> "TRUE" : "FALSE")]);
	u.printf("CE22: TRUE = %s\n", [(TRUE \/ TRUE -> "TRUE" : "FALSE")]);
	u.printf("CE23: TRUE = %s\n", [(TRUE \/ FALSE -> "TRUE" : "FALSE")]);
	u.printf("CE24: TRUE = %s\n", [(FALSE \/ TRUE -> "TRUE" : "FALSE")]);
	u.printf("CE25: FALSE = %s\n", [(FALSE \/ FALSE -> "TRUE" : "FALSE")]);
end

signexpr() do
	u.printf("SE01: 408 = %d\n", [(12 * 34)]);
	u.printf("SE02: -408 = %d\n", [(12 * -34)]);
	u.printf("SE03: 408 = %d\n", [(12 .* 34)]);
	u.printf("SE04: -408 = %d\n", [(12 .* -34)]);
	u.printf("SE05: 41 = %d\n", [(123 / 3)]);
	u.printf("SE06: -41 = %d\n", [(123 / -3)]);
	u.printf("SE07: 41 = %d\n", [(123 ./ 3)]);
	u.printf("SE08: 0 = %d\n", [(123 ./ -3)]);
	u.printf("SE09: 1 = %d\n", [(-2 ./ -2)]);
	u.printf("SE10: -1 = %d\n", [(5 < 7)]);
	u.printf("SE11: 0 = %d\n", [(5 > 7)]);
	u.printf("SE12: -1 = %d\n", [(5 <= 7)]);
	u.printf("SE13: 0 = %d\n", [(5 >= 7)]);
	u.printf("SE14: 0 = %d\n", [(5 < -7)]);
	u.printf("SE15: -1 = %d\n", [(5 > -7)]);
	u.printf("SE16: 0 = %d\n", [(5 <= -7)]);
	u.printf("SE17: -1 = %d\n", [(5 >= -7)]);
	u.printf("SE18: -1 = %d\n", [(5 .< 7)]);
	u.printf("SE19: 0 = %d\n", [(5 .> 7)]);
	u.printf("SE20: -1 = %d\n", [(5 .<= 7)]);
	u.printf("SE21: 0 = %d\n", [(5 .>= 7)]);
	u.printf("SE22: -1 = %d\n", [(5 .< -7)]);
	u.printf("SE23: 0 = %d\n", [(5 .> -7)]);
	u.printf("SE24: -1 = %d\n", [(5 .<= -7)]);
	u.printf("SE25: 0 = %d\n", [(5 .>= -7)]);
end

parentest() do
	u.printf("PA01: -14 = %d\n", [(11 - 5 - 7 - 13)]);
	u.printf("PA02: -14 = %d\n", [((11 - 5) - 7 - 13)]);
	u.printf("PA03: 0 = %d\n", [(11 - (5 - 7) - 13)]);
	u.printf("PA04: 12 = %d\n", [(11 - 5 - (7 - 13))]);
	u.printf("PA05: -14 = %d\n", [((11 - 5 - 7) - 13)]);
	u.printf("PA06: 26 = %d\n", [(11 - (5 - 7 - 13))]);
	u.printf("PA07: -14 = %d\n", [(((11 - 5) - 7) - 13)]);
	u.printf("PA08: 0 = %d\n", [((11 - (5 - 7)) - 13)]);
	u.printf("PA09: 26 = %d\n", [(11 - ((5 - 7) - 13))]);
	u.printf("PA10: 0 = %d\n", [(11 - (5 - (7 - 13)))]);
	u.printf("PA11: 12 = %d\n", [((11 - 5) - (7 - 13))]);
	u.printf("PA12: -36 = %d\n", [(11 * 5 - 7 * 13)]);
	u.printf("PA13: -36 = %d\n", [((11 * 5) - 7 * 13)]);
	u.printf("PA14: -286 = %d\n", [(11 * (5 - 7) * 13)]);
	u.printf("PA15: -36 = %d\n", [(11 * 5 - (7 * 13))]);
	u.printf("PA16: 624 = %d\n", [((11 * 5 - 7) * 13)]);
	u.printf("PA17: -946 = %d\n", [(11 * (5 - 7 * 13))]);
	u.printf("PA18: 624 = %d\n", [(((11 * 5) - 7) * 13)]);
	u.printf("PA19: -286 = %d\n", [((11 * (5 - 7)) * 13)]);
	u.printf("PA20: -286 = %d\n", [(11 * ((5 - 7) * 13))]);
	u.printf("PA21: -946 = %d\n", [(11 * (5 - (7 * 13)))]);
	u.printf("PA22: -36 = %d\n", [((11 * 5) - (7 * 13))]);
end

var RC;

recurse(n) if (n) do var i;
		RC := RC+1;
		i := recurse(n-1);
		if (i \= n-1)
			u.printf("RE01: recurse(%d) = %d\n", [(n-1,i)]);
		return n;
	end

decl mRecurse2(1);

mRecurse1(n) if (n) do
		RC := RC+3;
		mRecurse2(n-1);
	end

mRecurse2(n) if (n) do
		RC := RC-2;
		mRecurse1(n-1);
	end

recursion() do
	RC := 0;
	recurse(99);
	u.printf("RE02: 99 = %d\n", [(RC)]);
	RC := 0;
	mRecurse1(99);
	u.printf("RE03: 52 = %d\n", [(RC)]);
end

do
	printf();
	global_const();
	local_const();
	global_var();
	local_var();
	literals();
	static_tables();
	address_op();
	procedures();
	conditions();
	wloops();
	floops();
	condexpr();
	signexpr();
	parentest();
 	recursion();
end
